using System;
using System.ComponentModel;
using Syncfusion.Windows.Forms.Grid;

namespace CustomColumnExample
{
//	public delegate void CustomGridColumnWidthChangedEventHandler(object sender, CustomGridColumnWidthChangedEventArgs e);
//
//	public class CustomGridColumnWidthChangedEventArgs : EventArgs
//	{
//		public CustomGridColumnWidthChangedEventArgs(int width, string name)
//		{
//			this.width = width;
//			this.columnName = name;
//		}
//
//		private string columnName;
//		private int width;
//		public int Width
//		{
//			get{return width;}
//			set{width = value;}
//		}
//		public string ColumnName
//		{
//			get{return columnName;}
//			set{columnName = value;}
//		}
//	}
	/// <summary>
	/// A specialization of the <see cref="GridBoundColumn"/> class with additional
	/// functionality.
	/// </summary>
	public class CustomGridColumn : GridBoundColumn, ICloneable
	{
//		public event CustomGridColumnWidthChangedEventHandler WidthChanged; //event

        private int width;
        private int widthPercentage;

        /// <summary>
        /// Default constructor.
        /// </summary>
		public CustomGridColumn()
		{
		}

        public int Width
        {
            get { return width; }
            set { width = value; 
//					if(WidthChanged != null)     //event
//					{
//						CustomGridColumnWidthChangedEventArgs e = 
//							new CustomGridColumnWidthChangedEventArgs(width, this.MappingName);
//						OnWidthChanged(e);
//					}
				}
		}

//		protected virtual void OnWidthChanged(CustomGridColumnWidthChangedEventArgs e)
//		{
//			WidthChanged(this, e);
//		}

        public int WidthPercentage
        {
            get { return widthPercentage; }
            set { widthPercentage = value; }
        }

		public CustomGridColumn(PropertyDescriptor prop) 
			: base(prop)
		{
		}

		object ICloneable.Clone()
		{
			return base.Clone();
		}

		
	}

	[ListBindableAttribute(false)]
	[Editor(typeof(GridBoundColumnsCollectionEditor), typeof(System.Drawing.Design.UITypeEditor))]
	public class CustomGridColumnsCollection : GridBoundColumnsCollection, ICloneable
	{
		public CustomGridColumnsCollection(GridModelDataBinder table)
			: base(table)
		{
		}

		public override GridBoundColumn CreateBoundColumn(PropertyDescriptor pd)
		{
			return new CustomGridColumn(pd);
		}


		/// <summary>
		/// Creates a new <see cref="CustomGridColumnsCollection"/> and creates copies of all members in this collection.
		/// </summary>
		/// <returns>A <see cref="CustomGridColumnsCollection"/> object.</returns>
		public override object Clone()
		{
			GridModelDataBinder owner = null;
			owner = this.Owner;
			CustomGridColumnsCollection clone = new CustomGridColumnsCollection(owner);
			foreach (GridBoundColumn item in this)
				clone.Add((GridBoundColumn) item); //.Clone());
			return clone;
		}

		/// <overload>
		/// Gets a specified <see cref="CustomGridColumn"/> in the CustomGridColumnsCollection. 
		/// </overload>
		/// <summary>
		/// Gets a specified <see cref="CustomGridColumn"/> in the <see cref="CustomGridColumnsCollection"/>. 
		/// </summary>
		public new CustomGridColumn this[int index]
		{
			get
			{
				return (CustomGridColumn) base[index];
			}
		}

		/// <summary>
		/// Gets a specified <see cref="CustomGridColumn"/> in the CustomGridColumnsCollection. 
		/// </summary>
		public new CustomGridColumn this[string columnName]
		{
			get
			{
				return (CustomGridColumn) base[columnName];
			}
		}

		/// <summary>
		/// Gets a specified <see cref="CustomGridColumn"/> in the CustomGridColumnsCollection. 
		/// </summary>
		public new CustomGridColumn this[PropertyDescriptor propDesc]
		{
			get
			{
				return (CustomGridColumn) base[propDesc];
			}
		}
	}
}
